(in-package "XLISP")

(export 'style-warning)

(define-condition style-warning (simple-warning))

(export '(compile compile-file compile-file-pathname
          *compile-verbose* *compile-print*
          *compile-file-pathname* *compile-file-truename*))

(unless (fboundp 'old-compile)
        (setf (symbol-function 'old-compile) #'compile))
(unless (fboundp 'old-compile-file)
        (setf (symbol-function 'old-compile-file) #'compile-file))
(export '(old-compile old-compile-file))
(defpackage "NEWCMP" (:use "XLISP"))
(in-package "NEWCMP")

(defparameter *newcmp-files*
  '("environ" "intermed" "convert" "simplify" "cellstags" "lift"
    "gencode" "toplevel"))
(defun load-newcmp (&optional lspfiles)
  (if lspfiles
      (dolist (f *newcmp-files*) (load (merge-pathnames f ".lsp")))
    (dolist (f *newcmp-files*) (load f))))

(defun cmp-newcmp (&key (load t) (time t) (all t))
  (labels ((fsl-up-to-date (file)
             (let ((lspfile (merge-pathnames file ".lsp"))
                   (fslfile (merge-pathnames file ".fsl")))
               (and (probe-file lspfile)
                    (probe-file fslfile)
                    (< (file-write-date lspfile) (file-write-date fslfile)))))
           (make (file)
             (unless (and (not all) (fsl-up-to-date file))
                     (if time
                         (time (compile-file file :load load))
                       (compile-file file :load load)))))
    (let ((*warn-undeclared-globals* t))
      (if time
          (time (dolist (f *newcmp-files*) (make f)))
        (dolist (f *newcmp-files*) (make f))))))
(defun test-newcmp ()
  (dolist (f *newcmp-files*)
    (let ((tf (merge-pathnames ".test" f)))
      (when (probe-file tf) (load tf)))))
(load-newcmp)
